import java.net.*;
import java.io.*;
import java.util.*;
public class serversocket{
  public static void main( String[] args ) {
    // Se instancia el controlador de seguridad propio nuestro
    System.setSecurityManager( new MiSecurityManager() );
    // Se instancia un objeto servidor para escuchar el puerto 80
    Servidor servidor = new Servidor();   
    }
  }
class MiSecurityManager extends SecurityManager {
  public void checkRead( String str ) {}
  public void checkAccept( String s,int i ){}
  public void checkAccess( Thread t ){}
  public void checkAccess( ThreadGroup g ){} 
  public void checkAwtEventQueueAccess(){}
  public void checkConnect( String s,int i ){} 
  public void checkConnect( String s,int i,Object o ){}
  public void checkCreateClassLoader(){}
  public void checkDelete( String s ){}
  public void checkExec( String s ){}
  public void checkExit( int i ){}
  public void checkLink( String s ){}
  public void checkListen( int i ){}
  public void checkMemberAccess( Class c,int i ){}
  public void checkMulticast( InetAddress a ){}
  public void checkMulticast( InetAddress a,byte b ){}
  public void checkPackageAccess( String s ){}
  public void checkPackageDefinition( String s ){}
  public void checkPrintJobAccess(){}
  public void checkPropertiesAccess(){}
  public void checkPropertyAccess( String s ){}
  public void checkRead( FileDescriptor f ){}
  // public void checkRead( String s ){} // Este es el nico sobreescrito
  public void checkRead( String s,Object o ){}
  public void checkSecurityAccess( String s ){}
  public void checkSetFactory(){}
  public void checkSystemClipboardAccess(){}
  public boolean checkTopLevelWindow( Object o ) {return true;}
  public void checkWrite( FileDescriptor f ){}
  public void checkWrite( String s ){}
  }
class Servidor extends Thread {
  // Constructor
  Servidor() {
    // Arrancamos el hilo e invocamos al mtodo run() para que empiece
    // a correr
    start(); 
} 
public void run() {
    try {
      // Se instancia un objeto sobre el puerto 2000
      ServerSocket socket = new ServerSocket( 2000 );
      System.out.println( "Servidor escuchando el 2000" );
      while( true )
        // Nos quedamos parados en el accept(), y devolvemos un socket
        // cuando se recibe la llamada. Este socket es el que se pasa
        // como parmetro al nuevo hilo de ejecucin que se crea
        new ConexionServidor( socket.accept() );
    } catch( IOException e ) {
      e.printStackTrace();
      }
    }
  }

// Esta clase se utiliza la lanzar un hilo de ejecucin que atienda
// la llamada recibida a travs del puerto 2000, el puerto de eco
class ConexionServidor extends Thread {
  Socket socket;
  static String luces="apagadas";
  static String puertas="cerradas";

  // Constructor
  ConexionServidor( Socket socket ) {
    System.out.println( "Recibida una llamada en el puerto 2000" );
    this.socket = socket;
    // Trabajamos por debajo de la prioridad de los otros puertos
    setPriority( NORM_PRIORITY-1 );
    // Se arranca el hilo y se pone a correr
    start();
    }
   
  public void run() {
    System.out.println( "Lanzado el hilo de atencion del puerto 2000" );
    BufferedReader entrada = null;
    PrintWriter salida = null;
     
    try {
      // Conseguimos un canal de entrada desde el socket
      entrada = new BufferedReader( new InputStreamReader(
        socket.getInputStream() ) );
      // Conseguimos un canal de salida hacia el socket. El canal es
      // con liberacin automtica (autoflush)
      salida = new PrintWriter( new OutputStreamWriter(
        socket.getOutputStream()),true );

      // Recogemos la cadena que llegue al puerto y la devolvemos en
      // el mismo instante
      String cadena = entrada.readLine();
      
      System.out.println( "Recibido: "+cadena );
      
      int comando = Integer.parseInt(cadena);
      
      System.out.println( "Recibido: "+cadena );
      
      switch(comando)
      {
        case 1:
               luces="encendidas" ;
               salida.println("luces " + luces); break;
        case 2:
               luces="apagadas"; 
               salida.println("luces " + luces); break;

        case 3:
               puertas="abiertas" ;
               salida.println("puertas " + puertas); break;
        case 4:
               puertas="cerradas" ;
               salida.println("puertas " + puertas); break;
        case 5:
               salida.println("Estado actual: luces: "+ luces + " puertas: "+puertas); 
               break;
        default: salida.println("Comando no reconocido");
      }
      
      
      System.out.println( "Recibido: "+cadena );
      socket.close();
      System.out.println( "Socket cerrado" );
    } catch( IOException e ) {
      e.printStackTrace();
      }
    }
  }



// Esta es la clase que se utiliza para instanciar un hilo de ejecucin
// para el servidor que se encarga de escuchar el puerto 80, que es el
// definido como estndar para el protocolo de "http"
